scankborg equ 6000h ;the location of the keyboard lookup table (high byte)

org scankborg
ld sp,06fffh

setup232:
out (0e8h),a ;reset the uart
ld a,0eeh
out (0e9h),a ;set baud to 9600
ld a,11101100b ;set 8n1, and rts and dts
out (0eah),a

mloop:
push bc
call kbscan
pop bc
ld a,d
sub b
jp z,mloop ;lock into loop until a different key is pressed

ld a,d
sub 0ffh
jp z, skpo ;if there are unprintable characters, skip it
ld a,d
ld (3c00h),a

tt:
in a,(0eah)
bit 6,a
jp z,tt
ld a,d
out (0ebh),a

skpo:
ld b,d ;b now has last pressed key
jp mloop

kbscan: ;scans keyboard. Returns d, either scan code or ffh if no key pressed
push 
ld hl,3801h
ld c,255
ld d,0
KBreadA:
ld e,(hl)
ld a,08h
sub l
jp z, KBreadB
KbreadC:
ld b,0
KBreadrowB:
ld a,1
and e
jp nz, KBreadrowC
KBreadrowD:
rr e
inc d
ld a,7
cp b
jp z,kbreadrowE
inc b
jp kbreadrowB
kbreadrowE:
ld a,20H
sub l
jp z, KBreadX
rl l
jp KBreadA
KBreadB: ;add in arrows and space into row 08
ld a,(3840h)
and 0f8h
add a,e
ld e,a
jp KBreadC
KBreadrowC: ;if a key is found pressed, store that index
ld a,d
ld c,a
jp KBreadrowD
KBreadX: ;done scanning most keys, check modifiers
ld d,c
ld a,255
sub a,c
jp z,nnKey ;no (normal) key was pressed

ld a,(3840H) ;check control key (clear)
and 2
sub 2
jp nz,nClear
ld a,96
add a,c
ld c,a
nClear:

ld a,(3880H) ;check shift key
and 1
jp z,nShift
ld a,48
add a,c
ld c,a
nShift:

;get value from lookup table
ld hl,scankborg+100h
ld l,c
ld d,(hl)

nnKey:
ld a,(3840H) ;check enter/break keys
ld b,a
and 1
jp z,nEnter
ld a,0FEh
ld d,a
nEnter:
ld a,b
and 4
sub 4
jp nz,nBreak
ld a,0F0h
ld d,a
nBreak:

ret

seek 100h
incbin "kbmap.bin"