tout equ 6200h

org 6000h
ld sp,06fffh

scankb: ;scans keyboard. Returns a, either scan code or ffh if no key pressed
;Most keys work how you would expect (return ascii)
;This is custom. letters are lowercase except when SHIFTed. 
;Clear key functions as CONTROL key, and can be used to type ascii control characters (^C, ^X, etc.)
;Break, arrows, enter return special values (used to do special function)
ld hl,3801h
ld c,255
ld d,0
KBreadA:
ld e,(hl)
ld a,08h
sub l
jp z, KBreadB
KbreadC:
ld b,0
KBreadrowB:
ld a,1
and e
jp nz, KBreadrowC
KBreadrowD:
rr e
inc d
ld a,7
cp b
jp z,kbreadrowE
inc b
jp kbreadrowB
kbreadrowE:
ld a,20H
sub l
jp z, KBreadX
rl l
jp KBreadA
KBreadB: ;add in arrows and space into row 08
ld a,(3840h)
and 0f9h
add a,e
ld e,a
jp KBreadC
KBreadrowC: ;if a key is found pressed, store that index
ld a,d
ld c,a
jp KBreadrowD
KBreadX: ;done scanning most keys, check modifiers
ld a,(3880h)
and 1
ld b,a
ld a,(3840h)
and 6
add a,b
ld b,a
;now c has the key matrix, b has shift,break,clear
ld a,c
ld d,c
sub 255
jp nz, KBreadY
jp q ;no key pressed
KBreadY: ;done scanning keys, start decoding

ld a,c
add a,60h ;assume (letters) are lowercase
ld d,a

ld a,b ;make keys uppercase if shift was held
and 1
sub 1
jp nz, KBdecA 
ld a,c
add a,40h 
ld d,a
KBdecA:

ld a,b ;make keys control codes if clear was held
and 2h
sub 2h
jp nz, KBdecB
ld a,c
ld d,a
KBdecB:

ld a,c ;process number keys
and 20h
sub 20h
jp nz, KBdecC
ld a,c
add a,10h
ld d,a
ld a,1
and b
jp z, KBdecC
ld d,c
KBdecC:

KBtrnA: ;translate misc keys
ld a,d
sub 2ch
jp nz,KBtrnB
ld d,3ch
KBtrnB:
sub 1h
jp nz,KBtrnC
ld d,3dh
KBtrnC:
sub 1h
jp nz,KBtrnD
ld d,3eh
KBtrnD:
sub 1h
jp nz,KBtrnE
ld d,3fh
KBtrnE:
sub 0Dh
jp nz,KBtrnF
ld d,2ch
KBtrnF:
sub 1h
jp nz,KBtrnG
ld d,2dh
KBtrnG:
sub 1h
jp nz,KBtrnH
ld d,2eh
KBtrnH:
sub 1h
jp nz,KBtrnI
ld d,2fh
KBtrnI:
sub 21h
jp nz,KBtrnJ
ld d,40h
KBtrnJ:

sub 1Bh
jp nz,KBtrnK
ld d,81h
KBtrnK:
sub 1h
jp nz,KBtrnL
ld d,82h
KBtrnL:
sub 1h
jp nz,KBtrnM
ld d,83h
KBtrnM:
sub 1h
jp nz,KBtrnN
ld d,84h
KBtrnN:

sub 1h
jp nz,KBtrnO
ld d,20h
KBtrnO:

ld a,b ;do these translations only if clear key held
and 2h
sub 2h
jp nz, KBtrn2Z
ld a,c
sub 1bh
jp nz,KBtrn2B
ld d,1fh
KBtrn2B:
sub 1h
jp nz,KBtrn2C
ld d,1eh
KBtrn2C:
sub 1h
jp nz,KBtrn2D
ld d,1dh
KBtrn2D:
sub 1h
jp nz,KBtrn2E
ld d,1ch
KBtrn2E:
sub 03h
jp nz,KBtrn2F
ld d,7fh
KBtrn2F:
sub 1h
jp nz,KBtrn2G
ld d,7eh
KBtrn2G:
sub 5h
jp nz,KBtrn2I
ld d,60h
KBtrn2I:
sub 1h
jp nz,KBtrn2P
ld d,7Bh
KBtrn2P:
sub 1h
jp nz,KBtrn2R
ld d,7Dh
KBtrn2R:
sub 1h
jp nz,KBtrn2J
ld d,7ch
KBtrn2J:
sub 1h
jp nz,KBtrn2K
ld d,5eh
KBtrn2K:
sub 1h
jp nz,KBtrn2L
ld d,5bh
KBtrn2L:
sub 1h
jp nz,KBtrn2M
ld d,5fh
KBtrn2M:
sub 1h
jp nz,KBtrn2N
ld d,5dh
KBtrn2N:
sub 1h
jp nz,KBtrn2Z
ld d,5ch
KBtrn2Z:

ld a,(3840H) ;read the enter key
and 1
jp z,KBtrnEN
ld d,128 ;special enter
ld a,b ;do these translations only if clear key held
and 2h
sub 2h
jp nz, KBtrnEN
ld d,27 ;escape
KBtrnEN:

ld a,(3840H) ;read the break key
and 4
sub 4
jp nz, KBtrnBN
ld d,90h ;break
KBtrnBN:


 
q:
ld a,d
jp 6000h

